#!/sbin/sh -
# 
# *****************************************************************
# *                                                               *
# *    Copyright (c) Digital Equipment Corporation, 1991, 1995    *
# *                                                               *
# *   All Rights Reserved.  Unpublished rights  reserved  under   *
# *   the copyright laws of the United States.                    *
# *                                                               *
# *   The software contained on this media  is  proprietary  to   *
# *   and  embodies  the  confidential  technology  of  Digital   *
# *   Equipment Corporation.  Possession, use,  duplication  or   *
# *   dissemination of the software and media is authorized only  *
# *   pursuant to a valid written license from Digital Equipment  *
# *   Corporation.                                                *
# *                                                               *
# *   RESTRICTED RIGHTS LEGEND   Use, duplication, or disclosure  *
# *   by the U.S. Government is subject to restrictions  as  set  *
# *   forth in Subparagraph (c)(1)(ii)  of  DFARS  252.227-7013,  *
# *   or  in  FAR 52.227-19, as applicable.                       *
# *                                                               *
# *****************************************************************
#
# HISTORY
# 
# @(#)$RCSfile: voladm_lib.sh,v $ $Revision: 1.1.12.2 $ (DEC) $Date: 1995/08/14 18:20:54 $
# 
# @(#)src/common/cmd/vxvm/voladm/voladm_lib.sh	5.14 16 Mar 1993 01:20:44 - Copyright (c) 1993 VERITAS Software Corp.
#ident	"@(#)vxvm:common/cmd/vxvm/voladm/voladm_lib.sh	5.14"

# Copyright(C)1993 VERITAS Software Corporation.  ALL RIGHTS RESERVED.
# UNPUBLISHED -- RIGHTS RESERVED UNDER THE COPYRIGHT
# LAWS OF THE UNITED STATES.  USE OF A COPYRIGHT NOTICE
# IS PRECAUTIONARY ONLY AND DOES NOT IMPLY PUBLICATION
# OR DISCLOSURE.
# 
# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND
# TRADE SECRETS OF VERITAS SOFTWARE.  USE, DISCLOSURE,
# OR REPRODUCTION IS PROHIBITED WITHOUT THE PRIOR
# EXPRESS WRITTEN PERMISSION OF VERITAS SOFTWARE.
# 
#               RESTRICTED RIGHTS LEGEND
# USE, DUPLICATION, OR DISCLOSURE BY THE GOVERNMENT IS
# SUBJECT TO RESTRICTIONS AS SET FORTH IN SUBPARAGRAPH
# (C) (1) (ii) OF THE RIGHTS IN TECHNICAL DATA AND
# COMPUTER SOFTWARE CLAUSE AT DFARS 252.227-7013.
#               VERITAS SOFTWARE
# 4800 GREAT AMERICA PARKWAY, SANTA CLARA, CA 95054


VOLADM_ROOT=${VOLADM_ROOT-/sbin/lsm}
VOLUSRBIN=${VOLUSRBIN-/usr/sbin/lsm/bin}
VOLADM_BIN=${VOLADM_BIN-$VOLADM_ROOT/bin}
VOLADM_LIB=${VOLADM_LIB-$VOLADM_ROOT/lib}
VOLADM_HELP=${VOLADM_HELP-$VOLADM_ROOT/help}


export VOLADM_ROOT
export VOLADM_BIN
export VOLADM_LIB
export VOLADM_HELP

#NEED_PATH=/etc/vol/bin:$VOLADM_BIN:/usr/sbin:/sbin:/usr/bin
NEED_PATH=$VOLADM_BIN:/usr/sbin:/sbin:/usr/bin:/usr/sbin/lsm/bin
case $PATH in
$NEED_PATH|$NEED_PATH:*) ;;
*)	PATH=$NEED_PATH:$PATH; export PATH;;
esac

voladm_menu_stack=
cleanup_list=cleanup_tempfiles
newline='
'

v_opt=
verbose=
if [ "X$1" = X-v ]
then
	verbose=yes
	v_opt=-v
	shift
fi

tmpfile1=${TMPDIR:-/tmp}/vx1.$$
tmpfile2=${TMPDIR:-/tmp}/vx2.$$
tmpfile3=${TMPDIR:-/tmp}/vx3.$$
tmpdfile=${TMPDIR:-/tmp}/vx4.$$

cleanup_tempfiles()
{
	rm -f $tmpfile1 $tmpfile2 $tmpfile3 $tmpdfile
}

quit()
{
	trap "" 2 1 3 15
	for f in $cleanup_list
	do
		"$f"
	done
	exit $1
}

trap "quit 100" 2 1 3 15

exec 4<&0 5>&2

# doit - execute a command, printing the command in verbose mode
doit()
{
	[ "$verbose" ] && echo ! "$@" >&5
	"$@"
}

writemsg()
{
	echo "";
	for _wm_line in "$@"
	do
		echo "  $_wm_line"
	done
}

read_input()
{
	echo ""
	_once=
	if [ "X$1" = X-m ]
	then
		_once=yes
		shift
	fi
	_prompt="$1 "
	[ -z "$2" ] || _prompt="${_prompt}[$2,q,?] "
	[ -z "$3" ] || _prompt="${_prompt}(default: $3) "
	case $_prompt in
	??????????????????????????????????????????????????????????????????*)
		if [ ! -z "$2" ] || [ ! -z "$3" ]
		then
			_prompt="$1$newline"
			[ -z "$2" ] || _prompt="${_prompt}[$2,q,?] "
			[ -z "$3" ] || _prompt="${_prompt}(default: $3) "
		fi
		;;
	esac
	while true
	do
		echo "$_prompt\c"
		read input <&4
		case $input in
		"")	input=$3; return 0;;
		"!")	${SHELL:-sh} <&4
			echo !
			[ ! -z "$_once" ] && return 1;;
		"!"*)	${SHELL:-sh} -c "`expr "$input" : '!\(.*\)'" <&4
			echo !
			[ ! -z "$_once" ] && return 1;;
		'?')	voladm_help; [ ! -z "$_once" ] && return 1;;
#		'??')	voladm_help_help; [ ! -z "$_once" ] && return 1;;
		q)	quit 101;;
		x)	quit 100;;
		*)	return 0;;
		esac
	done
}

pop_list()
{
	_list=$1
	eval "set -- \$$_list"
	shift
	eval "$_list=\$*"
}

first_item()
{
	echo $1
}

list_item()
{
	_item=$1
	shift
	eval "echo \${$_item}"
}

list_count()
{
	echo $#
}

push_list()
{
	_list=$1
	shift
	eval "set -- \$* \$$_list"
	eval "$_list=\$*"
}

append_list()
{
	_list=$1
	shift
	eval "set -- \$$_list \$*"
	eval "$_list=\$*"
}

list_member()
{
	_want=$1
	shift
	for i in $@
	do
		[ "X$_want" = "X$i" ] && return 0
	done
	return 1
}

not()
{
	"$@"
	[ $? -eq 0 ] && return 1
	return 0
}

add_cleanup()
{
	push_list cleanup_list $*
}

voladm_menu_push()
{
	push_list voladm_menu_stack $VOLADM_CURRENT_MENU
	if [ -z "$VOLADM_CURRENT_MENU" ]
	then
		VOLADM_CURRENT_MENU=$1
	else
		VOLADM_CURRENT_MENU=$VOLADM_CURRENT_MENU/$1
	fi
	export VOLADM_CURRENT_MENU
}

voladm_menu_pop()
{
	VOLADM_CURRENT_MENU=`first_item $voladm_menu_stack`
	export VOLADM_CURRENT_MENU
	pop_list voladm_menu_stack
}

voladm_menu_set()
{
	voladm_menu_pop
	voladm_menu_push $1
}

voladm_help_push()
{
	voladm_help_stack="$VOLADM_CURRENT_HELP $voladm_help_stack"
	VOLADM_CURRENT_HELP=$1
	export VOLADM_CURRENT_HELP
}

voladm_help_pop()
{
	VOLADM_CURRENT_HELP=`first_item $voladm_help_stack`
	export VOLADM_CURRENT_HELP
	pop_list voladm_help_stack
}

voladm_help_set()
{
	voladm_help_pop
	voladm_help_push $1
}

voladm_help_help()
{
	voladm_help voladm.info
}

voladm_help()
{
	help=${1:-$VOLADM_CURRENT_HELP}
	if [ -x /usr/bin/tput ] && [ ! -z "$TERM" ]
	then
		tput clear
	fi
#if [ `uname -m` = "hitm" ]; then
	( echo "$title\nMenu: $VOLADM_CURRENT_MENU\n"
	  grep -v "^#" $VOLADM_HELP/$help
	  echo "" ) > /tmp/voladm_help.$$ 
	  voladm_display /tmp/voladm_help.$$
	  rm -f /tmp/voladm_help.$$
#else
#	( echo "$title\nMenu: $VOLADM_CURRENT_MENU\n"
#	  grep -v "^#" $VOLADM_HELP/$help
#	  echo "" ) | voladm_display
#	  echo "" )
#fi
}

# display something, using a pager, if needed
voladm_display()
{
	cat "$@" > $tmpdfile
	lines=`tput lines`
	[ -z "$lines" ] && lines=24
	if [ "`wc -l < $tmpdfile`" -ge $lines ]
	then
		${PAGER:-pg} $tmpdfile <&4
	else
		cat $tmpdfile
	fi
}

voladm_call()
{
	_util=$1
	shift

	doit "$_util" $v_opt "$@" <&4
	status=$?
	if [ $status -eq 100 ] || [ $status -eq 101 ]
	then
		quit $status
	fi
	return $status
}

voladm_menu_call()
{
	_util=$1
	shift

	doit "$_util" $v_opt "$@" <&4
	status=$?
	if [ $status -eq 100 ]
	then
		quit 100
	fi
	return $status
}

voladm_begin_screen()
{
	tput clear
	echo "\n$1\nMenu: $VOLADM_CURRENT_MENU"
}

voladm_menu()
{
	read _menu_title
	_menu_default=
	_menu="$_menu_title\nMenu: $VOLADM_CURRENT_MENU\n"
	_menu_select='case $input in'
	while read _menu_key _menu_item _menu_text
	do
		if [ -z "$_menu_key" ]
		then
			_menu="$_menu\n"
		elif [ "X$_menu_item" = Xdefault ]
		then
			_menu_default=$_menu_key
		else
			_menu_select="$_menu_select '$_menu_key')VOLADM_MENU_SELECT=$_menu_item;break 2;;"
			if [ ! -z "$_menu_text" ]
			then
				_menu="$_menu\n $_menu_key\t$_menu_text"
			fi
		fi
	done
	_menu_select="$_menu_select *) ;; esac"
	_menu="$_menu\n ?\tDisplay help about menu"
#	_menu="$_menu\n ??\tDisplay help about the menuing system"
	_menu="\n$_menu\n q\tExit from menus"
	_menu_prompt="${1:-Select an operation to perform:}"
	if [ ! -z "$_menu_default" ]
	then
		_menu_prompt="$_menu_prompt [default: $_menu_default]"
	fi

	while true
	do
		tput clear
		echo "$_menu"
		while true
		do
			read_input -m "$_menu_prompt" "" $_menu_default
			if [ $? -ne 0 ]
			then
				voladm_continue
				continue 2
			fi
			eval "$_menu_select"

			case $input in
			x)	quit 100;;
			q)	quit 101;;
			'?')	voladm_help; continue 2;;
			h)	voladm_help; continue 2;;
			help)	voladm_help; continue 2;;
#			'??')	voladm_help_help; continue 2;;
			esac
			writemsg "Selection not recognized, enter ? for help"
		done
	done

	echo ""
}

# voladm_yorn question default
voladm_yorn()
{
	while true
	do
		read_input "$1" "y,n" $2
		case $input in
		y|yes)	return 0;;
		n|no)	return 1;;
		*)	writemsg "Please respond with \"y\" or \"n\""
			continue;;
		esac
	done
}

# voladm_continue purpose
voladm_continue()
{
	echo "${1:-Hit RETURN to continue.}\c"
	read _continue <&4
	case $_continue in
	q)	quit 101;;
	x)	quit 100;;
	*)	return 0;;
	esac
}

# Like voladm_continue, but no quit option.
voladm_do_continue()
{
	echo "${1:-Hit RETURN to continue.}\c"
	read _continue <&4
	return 0
}

# voladm_disk_device purpose [default [select-list]]
voladm_disk_device()
{
	while true
	do
		read_input "$1" "${3:-<disk/partition name>,list}" $2
		device=$input
		[ "X$device" = "X$2" ] && return 0
#if [ `uname -m` = 'hitm' ]; then
#		case $device in
#		ckd*) daname=${device}; return 0;;
#		list|l)	voldevlist > /tmp/voladm_disk_device.$$
#			voladm_display /tmp/voladm_disk_device.$$
#			rm -f /tmp/voladm_disk_device.$$
#			continue;;
#		*) writemsg "Input not recognized, enter ?? for help";;
#		esac
#else
#		case $device in
#		c[0-9]t[0-9]d[0-9]) daname=${device}s0; return 0;;
#		list|l)	(echo ""; voldevlist; echo "") | voladm_display
#			continue;;
#		*) writemsg "Input not recognized, enter ?? for help";;
#		esac
#fi
		case $device in
		rz*) daname=${device}; return 0;;
		ra*) daname=${device}; return 0;;
		re*) daname=${device}; return 0;;
		list|l)	voldevlist > /tmp/voladm_disk_device.$$
			voladm_display /tmp/voladm_disk_device.$$
			rm -f /tmp/voladm_disk_device.$$
			continue;;
		*) writemsg "Input not recognized, enter ? for help";;
		esac
	done
}

# voladm_disk_group purpose default
voladm_disk_group()
{
	_new_group_okay=
	if [ X$1 = X-n ]
	then
		_new_group_okay=yes
		shift
	fi
	_opt="<group>,list"
	[ $# -eq 3 ] && _opt="<group>,none,list"
	_default=$2
	_prompt=$1
	while true
	do
		read_input "Which disk group" "$_opt" $_default
		dgname=$input
#if [ `uname -m` = "hitm" ]; then
		case $dgname in
		"")	writemsg "A disk group name is required."
			continue;;
		list|l)	voldg list > /tmp/voladm_disk_group.$$
			voladm_display /tmp/voladm_disk_group.$$
			rm -f /tmp/voladm_disk_group.$$
			continue;;
		*" "* | *"	"*)
			writemsg "Disk group name $dgname is not valid."
			continue;;
		none)	[ $# -eq 3 ] && return 0;;
		esac
#else
#		case $dgname in
#		"")	writemsg "A disk group name is required."
#			continue;;
#		list|l)	(echo ""; voldg list; echo "") | voladm_display
#			continue;;
#		*" "* | *"	"*)
#			writemsg "Disk group name $dgname is not valid."
#			continue;;
#		none)	[ $# -eq 3 ] && return 0;;
#		esac
#fi
		_voldg_output=`voldg -q list | grep "^\$dgname[ 	]"`
		if [ `list_count $_voldg_output` -ne 3 ]
		then
			writemsg "There is no active disk group named $dgname."
			if [ -n "$_new_group_okay" ] &&
			   voladm_yorn "Create a new group named $dgname?" y
			then
				return 10
			fi
			continue
		fi
		if [ "X`list_item 2 $_voldg_output`" != Xenabled ]
		then
			writemsg \
		 "Disk group $dgname is not currently usable due to errors."
			continue
		fi
		return 0
	done
}

voladm_new_disk_dmname()
{
	if [ -x $VOLUSRBIN/volparms ]; then 
		_default_dmname=`volnewdmname "$1"`
	else
		_default_dmname="$2"
	fi

	read_input "Enter disk name" "<name>" $_default_dmname
	dmname=$input
	return 0
}

voladm_get_disk_dmname()
{
	_dm_want_removed=
	if [ "X$1" = X-r ]
	then
		_dm_want_removed=yes
		shift
	fi
	_dm_want_spec_dg=
	if [ "X$1" = X-g ]
	then
		shift
		_dm_want_spec_dg=$1
		shift
	fi
	_dm_prompt="${1:-Enter disk name}"
	_default=$2

	while true
	do
		read_input "$_dm_prompt" "<disk>,list" $_default
		dmname=$input
#if [ `uname -m` = "hitm" ]; then
		case $input in
		"")	writemsg \
	 "Please enter a disk name, or type \"list\" to list all disks."
			continue;;
		$_default)
			return 0;;
		list|l)	if [ "$_dm_want_removed" ]
			then
				(echo ""
				 if [ -z "$_dm_want_spec_dg" ]
				 then
				 	volprint -Atd
				 else
				 	volprint -td -g "$_dm_want_spec_dg"
				 fi |
					awk '$1!="dm" || $3=="-" {print $0;}'
				 echo "") > /tmp/voladm_get_disk_dmname.$$
				 voladm_display /tmp/voladm_get_disk_dmname.$$
				 rm -f /tmp/voladm_get_disk_dmname.$$
			else
				volprint -Atd > /tmp/voladm_get_disk_dmname.$$
				voladm_display /tmp/voladm_get_disk_dmname.$$
				rm -f /tmp/voladm_get_disk_dmname.$$
			fi
			continue
			;;
		esac
#else
#		case $input in
#		"")	writemsg \
#	 "Please enter a disk name, or type \"list\" to list all disks."
#			continue;;
#		$_default)
#			return 0;;
#		list|l)	if [ "$_dm_want_removed" ]
#			then
#				(echo ""
#				 if [ -z "$_dm_want_spec_dg" ]
#				 then
#				 	volprint -Atd
#				 else
#				 	volprint -td -g "$_dm_want_spec_dg"
#				 fi |
#					awk '$1!="dm" || $3=="-" {print $0;}'
#				 echo "") | voladm_display
#			else
#				(echo ""; volprint -Atd; echo "") |
#					voladm_display
#			fi
#			continue
#			;;
#		esac
#fi
		if [ -z "$_dm_want_spec_dg" ]
		then
			set -- `volprint -AQF "%dgname" "\$dmname" 2> /dev/null`
		else
			set -- `volprint -g "$_dm_want_spec_dg" \
					-F "%dgname" "\$dmname" 2> /dev/null`
		fi
		if [ $# -eq 0 ] && [ -z "$_dm_want_spec_dg" ]
		then
			writemsg \
	 "There is no disk named $dmname in any disk group configuration." \
	 "To get a list of disks enter \"list\"."
			continue
		elif [ $# -eq 0 ]
		then
			writemsg \
	 "There is no disk named $dmname in disk group $_dm_want_spec_dg." \
	 "To get a list of disks enter \"list\"."
		fi
		break
	done
	if [ $# -eq 1 ]
	then
		dgname=$1
		return 0
	fi
	break
	writemsg \
	 "There is a disk named $dmname in each of the following disk groups:" \
	 "\t$*"
	while true
	do
		read_input "Enter the disk group to use" "group" $1
		for dgname in $*
		do
			if [ "X$dgname" = "X$input" ]
			then
				return 0
			fi
		done
		writemsg "Please choose a disk group from the list:\n\n\t$*"
	done
}

# re-online all online disks
voladm_reonline_all()
{
	voldisk -q list |
	while read daname type disk group status
	do
		if [ "X$group" = X- ] && not list_member offline $status
		then
			doit voldisk online $device 2> /dev/null
		fi
	done
}

# get the system hostid from the volboot file in system_hostid
voladm_system_hostid()
{
	system_hostid=
	system_hostid=`voldctl list | grep '^hostid:' |
			{ read key hostid; echo "$hostid"; }`
	if [ -z "$system_hostid" ]
	then
		writemsg \
	 "Unexpected internal error -- Cannot get the system's hostid."
		return 1
	fi
	return 0
}


# Detremine optimal values of nconfig and nlog based on the number of 
# disks already present in the diskgroup. 
get_disk_params()
{
	dgname=$1

	# Get the largest private region size in the diskgroup. 
	# "nopriv" disks have a privlen of 0 and hence should not 
	# be used in getting the privlen value below. 
        privlen=`volprint -htdq -g $dgname | awk '{if($5 != 0 && $5 != "-") print $5}' | sort -n -r  | head -1`
	# Set the nconfig and nlog values dependent on the number 
        #  of disks already added to the diskgroup. 
	# Do not include "nopriv" disks that could have been added 
	# to the diskgroup. 
	numdm=`voldg list $dgname | grep 'config disk' | awk '{print $3}' | sort | uniq | wc -l`
	if [ $numdm -ge 6 ]; then 
		attrs="nconfig=0 nlog=0"
	elif [ $numdm -ge 2 ]; then 
		attrs="nconfig=1 nlog=1"
	else
		attrs="nconfig=2 nlog=2"
	fi
}


# Used in disk.init.sh to get an estimate on the size 
# of the new diskgroup being created. 
get_diskgroup_params()
{
	dgname=$1

	writemsg \
	"Approximate maximum number of physical disks that" \
	"will be added to the $dgname diskgroup."
	read_input "Number of disks" "e.g. 5,10,30,60" 10  
	numdisks=$input
	if [ -z "$numdisks" ]
	then
		numdisks=10
	fi
	if [ $numdisks -le 10 ]; then 
		privlen=512; 
		attrs="nconfig=2 nlog=2"
	elif [ $numdisks -lt 30 ]; then
		privlen=512; 
		attrs="nconfig=1 nlog=1";
	else 
		privlen=1024;
		attrs="nconfig=1 nlog=1";
	fi
}
